#ifndef OSA_MEMORY_H
#define OSA_MEMORY_H

#include "Api/OsaDef.h"

enum OsaMemoryPoolType {
  OSA_MEMORY_PAGED,
  OSA_MEMORY_NONPAGED
};

#ifndef _PNH_DEFINED
typedef int (OSA_CDECL* _PNH)(size_t);
#define _PNH_DEFINED
#endif

extern _PNH __newhandler;

_PNH OSA_CDECL _set_new_handler( _PNH pfnHandler );

void * OSA_CDECL operator new(size_t size);
void * OSA_CDECL operator new[](size_t size);
void * OSA_CDECL operator new(size_t size, OsaMemoryPoolType type);
void   OSA_CDECL operator delete(void *p);
void   OSA_CDECL operator delete[](void *p);

#if DBG
void * OSA_CDECL operator new(size_t size, char *szFileName, int nLine);
void * OSA_CDECL operator new[](size_t size, char *szFileName, int nLine);
void * OSA_CDECL operator new(size_t size, OsaMemoryPoolType type, char *szFileName, int nLine);

#define NEW ::new (__FILE__, __LINE__)

#endif


#endif
